require 'tk'

$fileName = ARGV[0]

root = TkRoot.new() { title $fileName }

text = TkText.new(root, 'wrap'=>'none')
bar = TkScrollbar.new(root, 'width'=>10, 'command'=>proc{ |args| text.yview(*args) })
text.yscrollcommand(proc{ |first, last| bar.set(first, last) })
text.focus()

buttons = TkFrame.new(root)
save = TkButton.new(buttons, 'text'=>'Save', 'command'=>proc{
  saveFile(text)
})
save.pack('side'=>'left', 'fill'=>'x', 'expand'=>true)
savequit = TkButton.new(buttons, 'text'=>'SaveAndQuit', 'command'=>proc{
  saveFile(text)
  root.destroy()
})
savequit.pack('side'=>'left', 'fill'=>'x', 'expand'=>true)
quit = TkButton.new(buttons, 'text'=>'QuitNoSave', 'command'=>proc{
  root.destroy()
})
quit.pack('side'=>'left', 'fill'=>'x', 'expand'=>true)

buttons.pack('side'=>'bottom', 'fill'=>'x')
bar.pack('side'=>'right', 'fill'=>'y')
text.pack('fill'=>'both', 'expand'=>true)

if File.exists?($fileName)
  file = File.open($fileName)
  file.each { |line|
    text.insert('end', line)
  }
end

def saveFile(text)
  file = File.open($fileName, "w")
  file.print(text.get("0.0", 'end-1char')) # Tk adds a "\n" for some #$^& reason
  file.close()
end

Tk.mainloop()
