# Builds a menu from /usr/lib/menu/*; docks in WM, if possible
# Author & Copyright: Kero van Gelder, GNU LGPL applies
#
# ToDo:
#  - update menu when file added/changed
#  - menu in "drag" mode (wise issue)
#  - menu must unmap when clicked outside it (wise issue)

require 'wise'

External = 678
Menu = 41

@menu = [Menu, "", []]

# Go find debian or familiar (iPAQ) menus
MenuDir = "/usr/lib/menu/"
dir = Dir.new(MenuDir)
dir.each { |name|
  next  if name == '.' or name == '..' or File.stat(MenuDir+name).directory?
  File.open(MenuDir+name, "r") { |f|
    content = f.read
    content.gsub! /\\\n/, ""
    str_ref = '("[^"]*"|[^\s]*)'
    content.scan(/\?package.*section=#{str_ref}.*title=#{str_ref}.*command=#{str_ref}/) { |section, second, third|
      parts = section.scan("[^/\"]+")
      title = second.gsub("\"", '')
      command = third.gsub("\"", '')

      menu = @menu
      parts[0..-1].each { |entry|
	# descend a tree for the right menu...
	submenu = menu[2].select { |m|
	  m[1] == entry
	}
	if submenu.empty?
	  menu[2] << [Menu, entry, []]
	  menu = menu[2].last
	else
	  menu = submenu[0]
	end
      }

      menu[2] << [External, title, command]
    }
  }
}

def stuff_menu(button, items)
  items.each { |item|
    case item[0]
    when External
      Wise::Button.new(button.menu, :text=>item[1]) {
	pid = fork { exec("#{item[2]}") }
 	Thread.new { Process.waitpid(pid) }
      }
    when Menu
      b = Wise::MenuButton.new(button.menu, :text=>item[1])
      stuff_menu(b, item[2])
    end
  }
end

@base = Wise::MenuButton.new(nil, :title=>"Ruby Menu", :text=>"Menu", :font=>Wise::Font.new("snap"),
			     :dock=>true, :border=>1, :space=>0)

stuff_menu(@base, @menu[2])

Serialize::serialize()
