# First app for RbTk; displays power-percentage left; docks in WM, if possible
# Author & Copyright: Kero van Gelder, GNU LGPL applies

require 'wise'

module Battery
  ProcBatt = "/proc/hal/battery"
  @power = Wise::Label.new(nil, :title=>"Ruby Battery", :dock=>true, :text=>"100", :font=>Wise::Font.new("snap"),
			   :space=>1)

  def Battery::show_apm(force=false)
    File.open("/proc/apm") { |f|
      apm = f.gets()
      if /(-?[0-9]+)%/ =~ apm
	if force or $1 != @prev
	  @power.bg = Wise::Color.new(200-$1.to_i, 100+$1.to_i, 40)
	  @power.text = $1
	  @prev = $1
	  @w.text = `cat /proc/hal/battery`  if @w and @w.mapped?
#	  GC.start()
	end
      end
    }
  end

  @power.bind("Expose") { show_apm(true) }
#@power.bind("Key-Q") { @pow_thread.kill(); @power.destroy() }
  @power.bind("Button-Release") {
    if @w
      @w.text = `cat #{ProcBatt}`
      @w.map
    else
      @w = Wise::Multi.new(nil, :modal=>@power, :text=>`cat #{ProcBatt}`, :font=>"snap")
      @w.bind("Destroy") { @w = nil }  # overrule(unmap)
    end
  }

  @pow_thread = Thread.new {
    loop {
      show_apm()
      sleep 1
    }
  }
end

Serialize::serialize()
