# Displays a Clock; docks in WM, if possible
# Author & Copyright: Kero van Gelder, GNU LGPL applies

require 'wise'

Short = "%H:%M"
Long = "%a %b %d %Y\n%H:%M %Z"

def show_time(force=false)
  $time = Time.now.strftime(Short)
  if $time != @prev or force
    @clock.text = $time
    @prev = $time
  end
end

@clock = Wise::Label.new(nil, :title=>"Ruby Clock", :dock=>true, :text=>"23:45", :font=>"snap",
			 :space=>1, :border=>0)
@clock.bind("Expose") { show_time(true) }
@clock.bind("Button-Release") {
  if @w
    @w.text = Time.now.strftime(Long)
    @w.map
  else
    @w = Wise::Multi.new(nil, :modal=>@clock, :align=>:center,
			 :text=>Time.now.strftime(Long),
			 :font=>"snap")
    @w.bind("Destroy") { @w = nil }  # overrule(unmap)
  end
}

@pow_thread = Thread.new {
  loop {
    show_time
    @w.text = Time.now.strftime(Long)  if @w
    sleep(60 - Time.now.sec)
  }
}

Serialize::serialize()
